unit Propedit;

{This is my general property editor class.
 I use this for any of my data aware components.

 ??odd that I was required to derive them my self, 
   sometimes Borland's approach to the vcl wasn't
   quite as logical as others}

{you know, I was going to document these, but I can't 
remember what each does. Note though, that some
of them provide access to the fields etc of a datasource,
while some provide them directly off the dataset, for
some of my components that bypass datasources.
I can't even remember why I wanted to do that!}

interface

uses dsgnintf, classes;

{ TDBStringProperty }

type
  TmyDBStringProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValueList(List: TStrings); virtual; abstract;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

type
  TmyDataFieldProperty = class(TmyDBStringProperty)
  public
    function GetDataSourcePropName: string; virtual;
    procedure GetValueList(List: TStrings); override;
  end;

type
  TmyFieldProperty = class(TmyDBStringProperty)
  public
    function GetDataSetPropName: string; virtual;
    procedure GetValueList(List: TStrings); override;
  end;

type
  TmyDatabaseNameProperty = class(TmyDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

implementation

uses DB, DBTables, SysUtils, TypInfo, LibConst, ProcDlg;

function TmyDBStringProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TmyDBStringProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

function TmyDataFieldProperty.GetDataSourcePropName: string;
begin
  Result := 'DataSource';
end;

procedure TmyDataFieldProperty.GetValueList(List: TStrings);
var
  Instance: TComponent;
  PropInfo: PPropInfo;
  DataSource: TDataSource;
begin
  Instance := GetComponent(0);
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo, GetDataSourcePropName);
  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
  begin
    DataSource := TObject(GetOrdProp(Instance, PropInfo)) as TDataSource;
    if (DataSource <> nil) and (DataSource.DataSet <> nil) then
      DataSource.DataSet.GetFieldNames(List);
  end;
end;

function TmyFieldProperty.GetDataSetPropName: string;
begin
  Result := 'Table';
end;

procedure TmyFieldProperty.GetValueList(List: TStrings);
var
  Instance: TComponent;
  PropInfo: PPropInfo;
  DataSet: TDataSet;
begin
  Instance := GetComponent(0);
  PropInfo := TypInfo.GetPropInfo(Instance.ClassInfo, GetDataSetPropName);
  if (PropInfo <> nil) and (PropInfo^.PropType^.Kind = tkClass) then
  begin
    DataSet := TObject(GetOrdProp(Instance, PropInfo)) as TDataSet;
    if (DataSet <> nil) then DataSet.GetFieldNames(List);
  end;
end;


procedure TmyDatabaseNameProperty.GetValueList(List: TStrings);
begin
  Session.GetDatabaseNames(List);
end;

end.
